LeetCode 416. Partition Equal Subset Sum

16 篇文章 0 订阅
10 篇文章 0 订阅

题目:Given a non-empty array containing only positive integers, find if the array can be partitioned into two subsets such that the sum of elements in both subsets is equal.

题目:给出一个非空正整数数组,问是否能将该数组拆分成两个数组,其中这两个数组的元素和相等。

Note:

  1. Each of the array element will not exceed 100.
  2. The array size will not exceed 200.

Example 1:

Input: [1, 5, 11, 5]

Output: true

Explanation: The array can be partitioned as [1, 5, 5] and [11].

Example 2:

Input: [1, 2, 3, 5]

Output: false

Explanation: The array cannot be partitioned into equal sum subsets.

解题过程:根据题目,显然当给出的数组的元素和为奇数时无法拆分出两个元素和相同的数组,因此将此作为一个判断条件;当元素和为偶数时,将问题转化成01背包问题,即将问题转化为用数组中的元素尽可能地塞进容量为sum/2(设数组元素和为sum)的背包,为什么可以这样转化呢?很简单,因为要将数组拆分成元素和相等的两个数组,我们只需在数组中挑出元素组成一个和为sum/2的数组就OK了,这就相当与01背包问题,而且每个元素自身的消耗和价值是相等的。空间复杂度为O(sum),时间复杂度为O(sum*size)(其中size为给出的数组的大小),代码如下:

class Solution {
private:
    bool equalHalf(vector<int> nums, int target){
        int size = nums.size();
        int f[target+1];
        for(int i = 0; i <= target; ++i){
            f[i] = 0;
        }
        for(int i = 0; i < size; ++i){
            for(int j = target; j >= nums[i]; --j){
                f[j] = f[j] > f[j-nums[i]] + nums[i] ? f[j]:f[j-nums[i]]+nums[i];
            }
        }
        if(f[target]==target) return true;
        return false;
    }
public:
    bool canPartition(vector<int>& nums) {
        int sum = 0;
        for(vector<int>::iterator it = nums.begin();it != nums.end();++it){
            sum += *it;
        }
        if(sum%2) return false;
        int target = sum / 2;
        return equalHalf(nums,target);
    }
};

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值